unit ABOUT;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TVersion = record
    Major: Integer;
    Minor: Integer;
    Release: Integer;
    Build: Integer;
  end;

  TAboutBox = class(TForm)
    OKButton: TButton;
    Bevel1: TBevel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    Timer1: TTimer;
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    Showing: boolean;
    function GetVersion: TVersion;
  public
    { Public 錾 }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.dfm}
uses SysUtils, GraphUtil;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  with GetVersion do
    Version.Caption := format('o[W %d.%d.%d Build[%d]',
                                [Major, Minor, Release, Build]);
  Showing := True;
end;

function TAboutBox.GetVersion: TVersion;
type
  TDWord = record  //o[W𕪊邽߂̃R[h
    Lo: Word;      //DWORD(32rbg)̉16rbg(WORD)
    Hi: Word;      //DWORD(32rbg)̏16rbg(WORD)
  end;
//var
//  Size: DWord;
//  PVersionInfo: Pointer;
//  PFixedInfo: ^tagVS_FIXEDFILEINFO;
//  Zero: Cardinal;
//  Block: string;
//  dwFileVersionMS: Cardinal;
//begin
//  Zero := 0;
//  Block :='\';
//  Size := GetFileVersionInfoSize(PChar(ParamStr(0)), Zero);
//  if Size<> 0 then
//  begin
//    Getmem(PVersionInfo, Size);
//    try
//      if GetFileVersionInfo(PChar(ParamStr(0)), Zero, Size, PVersionInfo) then
//        if VerQueryValue(PVersionInfo, PChar(Block), Pointer(PFixedInfo), Zero) then
//        with Result do
//        begin
//          Major := HiWord(PFixedInfo^.dwProductVersionMS);
//          Minor := LoWord(PFixedInfo^.dwProductVersionMS);
//          Release := HiWord(PFixedInfo^.dwProductVersionLS);
//          Build := LoWord(PFixedInfo^.dwProductVersionLS);
//        end;
//    finally
//      FreeMem(PVersionInfo);
//    end;
//  end;
var
  FileName: string;
  InfoSize, Wnd: DWORD;
  VerBuf: Pointer;
  FI: PVSFixedFileInfo;
  VerSize: DWORD;
begin
  with Result do
  begin
    Major := 0;
    Minor := 0;
    Release := 0;
    Build := 0;
  end;
  FileName := Application.ExeName;
  UniqueString(FileName);
  InfoSize := GetFileVersionInfoSize(PChar(FileName), Wnd);
  if InfoSize <> 0 then
  begin
    GetMem(VerBuf, InfoSize);
    try
      if GetFileVersionInfo(PChar(FileName), Wnd, InfoSize, VerBuf) then
        if VerQueryValue(VerBuf, '\', Pointer(FI), VerSize) then
        with Result do
        begin
          Major := HiWord(FI.dwProductVersionMS);
          Minor := LoWord(FI.dwProductVersionMS);
          Release := HiWord(FI.dwProductVersionLS);
          Build := LoWord(FI.dwProductVersionLS);
        end;
    finally
      FreeMem(VerBuf);
    end;
  end;

end;

procedure TAboutBox.FormPaint(Sender: TObject);
var
  StartColor: TColor;
  EndColor: TColor;
begin
  StartColor := GetHighLightColor(clBtnFace ,19);
  EndColor := GetShadowColor(clBtnFace ,-50);
  with Sender do
    GradientFillCanvas(Canvas, StartColor, EndColor, ClientRect, gdVertical);
end;

procedure TAboutBox.Timer1Timer(Sender: TObject);
  function LimitInc(Count, Limit, IncNum: Integer): Integer;
  begin
    Result := Count + IncNum;
    if Result > Limit then Result := Limit;
  end;
begin
  //tF[hCB
  if Showing then
  begin
    if AlphaBlendValue < 255 then
      AlphaBlendValue := LimitInc(AlphaBlendValue, 255, 10)
    else
    begin
      Timer1.Enabled := False;
      AlphaBlend := False;
    end;
  end;
end;

procedure TAboutBox.FormShow(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TAboutBox.FormHide(Sender: TObject);
  function LimitDec(Count, Limit, DecNum: Integer): Integer;
  begin
    Result := Count - DecNum;
    if Result < Limit then Result := Limit;
  end;
begin
  //tF[hAEg
  //tF[hC^C}[Ȃ̂͑̑()Lɂ邽߁B
  //tF[hAEg͑Ȃ̂SleepŁB
  Showing := False;
  Timer1.Enabled := False;
  AlphaBlend := True;
  while AlphaBlendValue > 0 do
  begin
    AlphaBlendValue := LimitDec(AlphaBlendValue, 0, 20);
    Refresh;
    Sleep(10);
  end;

end;

end.

