unit BatchResult;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, RichEdit;

type
  TResultForm = class(TForm)
    RichEdit1: TRichEdit;
    Button1: TButton;
    Timer1: TTimer;
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    Showing: boolean;
  public
    { Public 錾 }
    procedure AddStringSuccess(Text: String);
    procedure AddStringChange(Text: String);
    procedure AddStringAlert(Text: String);
  end;

var
  ResultForm: TResultForm;
  procedure Gradation(Canvas: TCanvas; ARect: TRect; Color: TColor);

implementation

uses
  GraphUtil;
{$R *.dfm}

{ TResultForm }

procedure TResultForm.FormCreate(Sender: TObject);
begin
  RichEdit1.Clear;
  RichEdit1.Lines.Add('wb for XP Ǎ');
  Showing := True;
end;

procedure TResultForm.FormPaint(Sender: TObject);
begin
  //tH[wiOf[VB
  Gradation(Canvas, ClientRect, Color);
end;

procedure TResultForm.AddStringSuccess(Text: String);
var
  Format: TCharFormat2;
begin
  FillChar(Format, SizeOf(Format), 0);
  with Format do
  begin
    cbSize := SizeOf(Format);
    dwMask := CFM_COLOR;
    crTextColor := ColorToRGB(clBtnText);
    RichEdit1.Perform(EM_SETCHARFORMAT, SCF_SELECTION, Longint(@Format));
  end;
  try
    RichEdit1.Lines.Add(Text);
  except
  end;
end;

procedure TResultForm.AddStringChange(Text: String);
var
  Format: TCharFormat2;
begin
  FillChar(Format, SizeOf(Format), 0);
  with Format do
  begin
    cbSize := SizeOf(Format);
    dwMask := CFM_BACKCOLOR + CFM_COLOR;
    crTextColor := ColorToRGB(clInfoText);
    crBackColor := ColorToRGB(clInfoBk);
    RichEdit1.Perform(EM_SETCHARFORMAT, SCF_SELECTION, Longint(@Format));
  end;
  try
    RichEdit1.Lines.Add(Text);
  except
  end;
end;

procedure TResultForm.AddStringAlert(Text: String);
var
  Format: TCharFormat2;
begin
  FillChar(Format, SizeOf(Format), 0);
  with Format do
  begin
    cbSize := SizeOf(Format);
    dwMask := CFM_BOLD + CFM_BACKCOLOR + CFM_COLOR;
    dwEffects := CFE_BOLD;
    crTextColor := ColorToRGB(clInfoText);
    crBackColor := ColorToRGB(clInfoBk);
    RichEdit1.Perform(EM_SETCHARFORMAT, SCF_SELECTION, Longint(@Format));
  end;
  try
    RichEdit1.Lines.Add(Text);
  except
  end;
end;

procedure Gradation(Canvas: TCanvas; ARect: TRect; Color: TColor);
var
  StartColor: TColor;
  EndColor: TColor;
begin
  StartColor := GetHighLightColor(Color ,19);
  EndColor := GetShadowColor(Color ,-50);
  GradientFillCanvas(Canvas, StartColor, EndColor, ARect, gdVertical);
end;


procedure TResultForm.Timer1Timer(Sender: TObject);
  function LimitInc(Count, Limit, IncNum: Integer): Integer;
  begin
    Result := Count + IncNum;
    if Result > Limit then Result := Limit;
  end;
begin
  //tF[hCB
  if Showing then
  begin
    if AlphaBlendValue < 255 then
      AlphaBlendValue := LimitInc(AlphaBlendValue, 255, 10)
    else
    begin
      Timer1.Enabled := False;
      AlphaBlend := False;
    end;
  end;
end;

procedure TResultForm.FormShow(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TResultForm.FormHide(Sender: TObject);
  function LimitDec(Count, Limit, DecNum: Integer): Integer;
  begin
    Result := Count - DecNum;
    if Result < Limit then Result := Limit;
  end;
begin
  //tF[hAEg
  //tF[hC^C}[Ȃ̂͑̑()Lɂ邽߁B
  //tF[hAEg͑Ȃ̂SleepŁB
  Showing := False;
  Timer1.Enabled := False;
  AlphaBlend := True;
  while AlphaBlendValue > 0 do
  begin
    AlphaBlendValue := LimitDec(AlphaBlendValue, 0, 20);
    Refresh;
    Sleep(10);
  end;

end;

end.
