unit MAIN;

interface

uses Windows, Messages, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, StdActns,
  ActnList, ToolWin, ExtActns, ExtDlgs, AppEvnts, ShadowWnd;

type
  TColorPickTargetPanel = (tpFirst, tpSecond);

  TMainForm = class(TForm)
    Panel1: TPanel;
    ColorPanel1: TPanel;
    ColorPanel2: TPanel;
    ImageList1: TImageList;
    StaticText1: TStaticText;
    StatusBar: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    MainMenu1: TMainMenu;
    BatchChange1: TMenuItem;
    ColorChange1: TMenuItem;
    ColorSelectAction11: TMenuItem;
    ColorSelectAction12: TMenuItem;
    Edit1: TMenuItem;
    File1: TMenuItem;
    FileExitItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    C1: TMenuItem;
    N1: TMenuItem;
    N11: TMenuItem;
    N2: TMenuItem;
    N21: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    P1: TMenuItem;
    ActionList1: TActionList;
    ColorChange: TAction;
    ColorPick1: TAction;
    ColorPick2: TAction;
    ColorSelectAction1: TAction;
    ColorSelectAction2: TAction;
    FileExit1: TAction;
    HelpAbout1: TAction;
    ColorSelect1: TColorSelect;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    OpenPicture1: TOpenPicture;
    SelectPictures: TOpenPicture;
    SavePicture1: TSavePicture;
    HelpOpen: TAction;
    N5: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    PaintBox1: TPaintBox;
    ColorInv: TAction;
    ColorGray: TAction;
    ColorInvGray: TAction;
    ColorProcRun: TAction;
    ModeMenu: TPopupMenu;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    modeChange: TAction;
    modeInv: TAction;
    modeGray: TAction;
    modeInvGray: TAction;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    procedure ActionList1Update(Action: TBasicAction; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure modeInvGrayExecute(Sender: TObject);
    procedure modeGrayExecute(Sender: TObject);
    procedure modeInvExecute(Sender: TObject);
    procedure modeChangeExecute(Sender: TObject);
    procedure ColorInvGrayExecute(Sender: TObject);
    procedure ColorGrayExecute(Sender: TObject);
    procedure ColorInvExecute(Sender: TObject);
    procedure ColorChangeExecute(Sender: TObject);
    procedure ColorProcRunExecute(Sender: TObject);
    procedure ColorPickUpdate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ToolBar1Resize(Sender: TObject);
    procedure ToolBar1CustomDraw(Sender: TToolBar; const ARect: TRect;
      var DefaultDraw: Boolean);
    function ApplicationEvents1Help(Command: Word; Data: Integer;
      var CallHelp: Boolean): Boolean;
    procedure HelpOpenExecute(Sender: TObject);
    procedure SelectPicturesAccept(Sender: TObject);
    procedure EditPaste1Update(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure SavePicture1Accept(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ColorPick2Execute(Sender: TObject);
    procedure ColorPick1Execute(Sender: TObject);
    procedure ColorSelectAction2Execute(Sender: TObject);
    procedure ColorSelectAction1Execute(Sender: TObject);
    procedure OpenPicture1Accept(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure NoSupportGraphic;
  private
    { Private 錾 }
    FFileName: String;
    FColorPickMode: Boolean;
    FColorPicking: Boolean;
    FColorPickTargetPanel: TColorPickTargetPanel;
    FColorBackup: TColor;
//    ImageShadowRight: TShadowWindow;
//    ImageShadowBottom: TShadowWindow;
    procedure SetFileName(FileName: String);
    procedure PictureEditStart;
    procedure ColorPick;
    procedure ColorPickExit;
    procedure ColorChangeLogic(WorkBitmap: TBitmap; cprMode:Integer);
    procedure ColorChangeBatch(Files: TStrings);
    procedure ColorProcRunCopy(Source: TAction);
    procedure WMDropFiles(var Msg: TWMDropFiles); Message WM_DropFiles;
    procedure Gradation(Canvas: TCanvas; ARect: TRect; Color: TColor);
    procedure HelpWindowInitialize;
    property PicFileName: String read FFileName write SetFileName;
    function PixelFormatToString(PixelFormat: TPixelFormat): String;
    function cprModeToString(cprMode: Integer):String;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

uses About, BatchResult, ShellAPI, SysUtils, Clipbrd, GraphUtil, HTMLHelpViewer;
//, CallHtmlHelp;

{$R *.dfm}

const
  cprChange = 19;
  cprInv = 20;
  cprGray = 21;
  cprInvGray =22;

//Windows.pasɐݒ肳ĂHH_WINTYPE̓}CN\tg̏ƍ\Ⴄ߁A
//ŉ߂Đ錾ĂBo[WȂ񂩂̂ȁB
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/Htmlhelp/str_hh_wintype.asp
type
  PtagHH_Wintype = ^TtagHH_WINTYPE;
  tagHH_WINTYPE = packed record
    cbStruct: Integer;
    fUniCodeStrings: Boolean;
    pszType: PChar;
    fsValidMembers: DWord;
    fsWinProperties: DWord;
    pszCaption: PChar;
    dwStyles: DWord;
    dwExStyles: DWord;
    rcWindowPos: TRect;
    nShowState: Integer;
    hwndHelp: HWND;
    hwndCaller: HWND;
    //paInfoTypes: PHH_Infotype;	//Ⴄ
    hwndToolBar: HWND;
    hwndNavigation: HWND;
    hwndHTML: HWND;
    iNavWidth: Integer;
    rcHTML: TRect;
    pszToc: PChar;
    pszIndex: PChar;
    pszFile: PChar;
    pszHome: PChar;
    fsToolBarFlags: DWord;
    fNotExpanded: Boolean;
    curNavType: Integer;
    //tabPos: Integer;			//Ⴄ
    idNotify: Integer;
    //tabOrder: array[0..18] of Byte;	//Ⴄ
    //cHistory: Integer;		//Ⴄ
    pszJump1: PChar;
    pszJump2: PChar;
    pszUrlJump1: PChar;
    pszUrlJump2: PChar;
    //rcMinSize: TRect;			//Ⴄ
    //cbInfoTYpes: Integer;		//Ⴄ
    //pszCustomTabs: Integer;		//Ⴄ
  end;
  TtagHH_WINTYPE = tagHH_WINTYPE;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  //ACRݒ
  Icon := Application.Icon;

  //u摜Fovsǂ̃tO
  FColorPickMode := False;

  //tH[փt@Chbv邱ƂŊJׂ̏
  DragAcceptFiles(Handle, true);

  //ACRփt@ChbvĂ炻J
  if ParamCount > 0 then
    if LowerCase(ExtractFileExt(ParamStr(1))) = '.bmp' then
    begin
      OpenPicture1.Dialog.FileName := ParamStr(1);
      OpenPicture1Accept(Self);
    end;
  ScrollBox1.DoubleBuffered := True;
  ToolBar1.DoubleBuffered := True;
  //I[v_CAOɊJƁAwvJȂȂ邱Ƃɑ΂ΏB
  //Ƀwv΂BߑRƂȂ邢ΏǂB
//  HelpWindowInitialize;
  //ƂAI[v_CAOgƃJgfBNgςB
  //ʖڂۂˁB
  //t@CtpXŎw肵Ă΂炵B
  With Application do HelpFile := ExtractFilePath(ExeName) + ExtractFileName(HelpFile);

  //C[W̉e
//  ImageShadowRight := TShadowWindow.CreateShadow(ScrollBox1, csRight);
//  ImageShadowBottom := TShadowWindow.CreateShadow(ScrollBox1, csBottom);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
//  ImageShadowRight.Free;
//  ImageShadowBottom.Free;
end;

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
  function DropItems(Index: Integer): String;
  var
    pFilename: PChar;
    Length: Integer;
  begin
    //hbvꂽt@C̃TCY擾
    Length := DragQueryFile(msg.Drop, Index, nil, 0) + 1;
    //pFilenameɏœTCỸm
    pFilename := AllocMem(Length);
    //GetMem(pFilename, Length);
    try
      DragQueryFile(msg.Drop, Index, pFilename, Length);
      Result := pFileName;
    finally
      //J
      FreeMem(pFilename);
    end;
  end;

var
  DropCount, Index: Integer;
  FileName: String;
  Files: TStringList;
begin
  //t@C̃hbv
  try
    //t@C擾
    DropCount := DragQueryFile(msg.Drop, $ffffffff, nil, 0);

    //t@CȂ΁AAF
    if DropCount > 1 then
    begin
      Files := TStringList.Create;
      try
        //hbvꂽrbg}bvt@CׂĎ擾
        for Index := 0 to DropCount -1 do
        begin
          FileName := DropItems(Index);
          if LowerCase(ExtractFileExt(FileName)) = '.bmp' then
            Files.Add(FileName);
        end;
        //wb for XP őOʂɕ\ĘAFsBMOSTʖڂB
        SetWindowPos(Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
        SetWindowPos(Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
//        BringWindowToTop(Handle);
        ColorChangeBatch(Files);
      finally
        Files.Free;
      end;
    end
    //t@CPȂΊJ
    else if DropCount = 1 then
    begin
      FileName := DropItems(0);
      if LowerCase(ExtractFileExt(FileName)) = '.bmp' then
      begin
        OpenPicture1.Dialog.FileName := FileName;
        OpenPicture1Accept(Self);
      end;
    end;
  finally
    //hbv̏IOSɒʒm
    DragFinish(msg.Drop);
  end;
end;

procedure TMainForm.OpenPicture1Accept(Sender: TObject);
begin
  //t@CJ
  PicFileName := OpenPicture1.Dialog.FileName;
  try
    Image1.Picture.LoadFromFile(PicFileName);
  except
    On EInvalidGraphic do NoSupportGraphic;
  end;
  PictureEditStart;
end;

procedure TMainForm.SavePicture1Accept(Sender: TObject);
begin
  //t@Cۑ
  PicFileName := SavePicture1.Dialog.FileName;
  Image1.Picture.SaveToFile(PicFileName);
end;

procedure TMainForm.SetFileName(FileName: String);
begin
  FFileName := FileName;
  SavePicture1.Dialog.FileName := FFileName;
  OpenPicture1.Dialog.FileName := FFileName;
  if FFileName <>'' then
    Caption := 'wb for XP -[' + ExtractFileName(FFileName) + ']'
  else
    Caption := 'wb for XP';
  Application.Title := Caption;
end;

procedure TMainForm.SelectPicturesAccept(Sender: TObject);
begin
  //t@CAFς(t@CI)
  ColorChangeBatch(SelectPictures.Dialog.Files);
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditCopy1Execute(Sender: TObject);
begin
  Clipboard.Assign(Image1.Picture);
end;

procedure TMainForm.EditPaste1Update(Sender: TObject);
begin
  //Nbv{[hBitmapȂ΁A
  //u\tvgpł悤ɂ
  try
    EditPaste1.Enabled := Clipboard.HasFormat(CF_BITMAP);
  except
    on EInvalidGraphic do NoSupportGraphic;
  end;
end;

procedure TMainForm.EditPaste1Execute(Sender: TObject);
begin
  if Clipboard.HasFormat(CF_BITMAP) then
  begin
    Image1.Picture.Bitmap.Assign(Clipboard);
    PicFileName := '';
    PictureEditStart;
  end;
end;

procedure TMainForm.HelpOpenExecute(Sender: TObject);
begin
  if FColorPickMode then
//    HtmlHelpShowTopic('hmEditColorSyringe.html')
//    Application.HelpSystem.ShowTopicHelp(
//      'hmEditColorSyringe.html',
//      Application.HelpFile)
    Application.HelpSystem.ShowContextHelp(1203, Application.HelpFile)
  else
//    HtmlHelpShowHelp;
    Application.HelpSystem.ShowHelp('' ,Application.HelpFile);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
var
  AboutBox: TAboutbox;
begin
  AboutBox := TAboutBox.Create(Self);
  try
    AboutBox.ShowModal;
  finally
    AboutBox.Release;//FreeɂĂ̂ŏC
  end;
end;

procedure TMainForm.ColorSelectAction1Execute(Sender: TObject);
begin
  //F1I
  ColorSelect1.Dialog.Color := ColorPanel1.Color;
  if ColorSelect1.Execute then
    ColorPanel1.Color := ColorSelect1.Dialog.Color;
end;

procedure TMainForm.ColorSelectAction2Execute(Sender: TObject);
begin
  //F2I
  ColorSelect1.Dialog.Color := ColorPanel2.Color;
  if ColorSelect1.Execute then
    ColorPanel2.Color := ColorSelect1.Dialog.Color;
end;

procedure TMainForm.ColorPickUpdate(Sender: TObject);
begin
  if not FColorPickMode then
  begin
    ColorPick1.Checked := false;
    ColorPick2.Checked := false;
  end
  else
  if  FColorPickTargetPanel = tpFirst then
    ColorPick1.Checked := true
  else
    ColorPick2.Checked := true;

end;

procedure TMainForm.ColorPick1Execute(Sender: TObject);
begin
  if FColorPickMode and (FColorPickTargetPanel = tpFirst) then ColorPickExit else
  begin
  //F1̒o
    FColorPickTargetPanel := tpFirst;
    ColorPick;
  end;
end;

procedure TMainForm.ColorPick2Execute(Sender: TObject);
begin
  if FColorPickMode and (FColorPickTargetPanel = tpSecond) then ColorPickExit else
  begin
    //F2̒o
    FColorPickTargetPanel := tpSecond;
    ColorPick;
  end;
end;

procedure TMainForm.ColorChangeExecute(Sender: TObject);
begin
  //FsAĕ`
  ColorChangeLogic(Image1.Picture.Bitmap, cprChange);
  Image1.Repaint;
end;

procedure TMainForm.ColorInvExecute(Sender: TObject);
begin
  //F]sAĕ`
  ColorChangeLogic(Image1.Picture.Bitmap, cprInv);
  Image1.Repaint;
end;

procedure TMainForm.ColorGrayExecute(Sender: TObject);
begin
  //O[XP[sAĕ`
  ColorChangeLogic(Image1.Picture.Bitmap, cprGray);
  Image1.Repaint;
end;

procedure TMainForm.ColorInvGrayExecute(Sender: TObject);
begin
  //F]O[XP[sAĕ`
  ColorChangeLogic(Image1.Picture.Bitmap, cprInvGray);
  Image1.Repaint;
end;

procedure TMainForm.ColorProcRunExecute(Sender: TObject);
begin
  if not Image1.Visible then Exit;
  //AFւc[{^Fւ̃[hImageIndex̒lɂ
  ColorChangeLogic(Image1.Picture.Bitmap, ColorProcRun.ImageIndex);
  Image1.Repaint;
end;

procedure TMainform.ColorProcRunCopy(Source: TAction);
begin
  ColorProcRun.ImageIndex := Source.ImageIndex;
  ColorProcRun.Caption := Source.Caption;
  ColorProcRun.Hint := Source.Hint;
end;


procedure TMainForm.modeChangeExecute(Sender: TObject);
begin
  ColorProcRunCopy(modeChange);
end;

procedure TMainForm.modeInvExecute(Sender: TObject);
begin
  ColorProcRunCopy(modeInv);
end;

procedure TMainForm.modeGrayExecute(Sender: TObject);
begin
  ColorProcRunCopy(modeGray);
end;

procedure TMainForm.modeInvGrayExecute(Sender: TObject);
begin
  ColorProcRunCopy(modeInvGray);
end;

procedure TMainForm.ToolBar1Resize(Sender: TObject);
begin
  //c[o[ڂĕ`
  ToolBar1.Refresh;
end;

procedure TMainForm.ToolBar1CustomDraw(Sender: TToolBar; const ARect: TRect;
  var DefaultDraw: Boolean);
begin
  //c[o[wiOf[V
  Gradation(Sender.Canvas, ARect, clBtnFace);
  DefaultDraw := true;
end;

procedure TMainForm.PaintBox1Paint(Sender: TObject);
begin
  //XN[o[yCg{bNXŖ߂ăOf[V
  with PaintBox1 do
  begin
    Gradation(Canvas, Rect(0, 0, Width, Height), clAppWorkSpace);
    Canvas.Brush.Style := bsSolid;
    Canvas.Brush.Color := 0;
  end;

  //C[Wɉe
//  ImageShadowRight.Control := Image1;
//  ImageShadowBottom.Control := Image1;
  if Image1.Visible then
    with Image1 do
    PaintBox1.Canvas.FillRect(Rect(Left+5, Top+5, Left +Width +5, Top +Height +5));
end;

procedure TMainForm.PictureEditStart;
begin
  //t@CJ̏
  StaticText1.Color := clInfoBk;
  StaticText1.Font.Color := clInfoText;

  //Jt@Č`\
  StaticText1.Caption := PixelFormatToString(Image1.Picture.Bitmap.PixelFormat);

  //\
  Image1.Visible := True;//ColorPickEnable;
  PaintBox1Paint(Self);
end;

procedure TMainForm.NoSupportGraphic;
begin
  Image1.Visible := False;
  StaticText1.Caption := 'T|[gtH[}bg';
  StaticText1.Color := clBtnFace;
  StaticText1.Font.Color := clBtnText;
end;

procedure TMainForm.ColorPick;
begin
  //F摜璊õ[hJn
  FColorPickMode := True;
  FColorPicking := False;
  Image1.Cursor := crCross;
  if FColorPickTargetPanel = tpFirst then
    FColorBackup := ColorPanel1.Color
  else
    FColorBackup := ColorPanel2.Color;
end;

procedure TMainForm.ColorPickExit;
begin
  //F摜璊õ[hI
  FColorPickMode := False;
  FColorPicking := False;
  Image1.Cursor := crDefault;
end;

procedure TMainForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //F摜璊õ[hJnŐFoJn
  if not FColorPickMode then Exit;
  if Button = mbLeft then
  begin
    FColorPicking := True;
    if FColorPickTargetPanel = tpFirst then
      ColorPanel1.Color := Image1.Canvas.Pixels[x,y]
    else
      ColorPanel2.Color := Image1.Canvas.Pixels[x,y];
  end;
end;

procedure TMainForm.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  //F摜璊õ[hJnŐFo
  if FColorPickMode and FColorPicking then
  begin
    if FColorPickTargetPanel = tpFirst then
      ColorPanel1.Color := Image1.Canvas.Pixels[x,y]
    else
      ColorPanel2.Color := Image1.Canvas.Pixels[x,y];
  end;
end;

procedure TMainForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //F摜璊õ[hJnŐFoI
  if not FColorPickMode then Exit;

  ColorPickExit;

  //ENbNȂ璊o(obNAbvColor𕜋A)
  if Button = mbRight then
  begin
    if FColorPickTargetPanel = tpFirst then
      ColorPanel1.Color := FColorBackup
    else
      ColorPanel2.Color := FColorBackup;
  end;
end;


procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //(摜̊OŃ}EX{^̏u)
  //F摜璊õ[hJnŐFoI
  //o(obNAbvColor𕜋A)
  if not FColorPickMode then Exit;

  ColorPickExit;

  if FColorPickTargetPanel = tpFirst then
    ColorPanel1.Color := FColorBackup
  else
    ColorPanel2.Color := FColorBackup;
end;

//procedure TMainForm.ColorChangeLogic(WorkCanvas: TBitmap; cprMode:Integer);
procedure TMainForm.ColorChangeLogic(WorkBitmap: TBitmap; cprMode:Integer);
var
//  PixelFormatBU: TPixelFormat;
  Row, Col: Integer;
  Line: PByteArray;
  Color1, Color2, CColor, GrayCode: Integer;
  WorkCanvas: TBitmap;
begin
  WorkCanvas := TBitmap.Create;
  try
    //F

    //TColorWindowsRGBo
    Color1 := ColorToRGB(ColorPanel1.Color);
    Color2 := ColorToRGB(ColorPanel2.Color);

    //[hobNAbvApf24bit
//    PixelFormatBU := WorkCanvas.PixelFormat;

    //16rbgtB[hɑΉ(pbg̕ssɑΏ)
    //ڕϊ̂ł͂ȂÄ̗ɕ`ɕύX
    WorkCanvas.PixelFormat := pf24bit;
    WorkCanvas.Width := WorkBitmap.Width;
    WorkCanvas.Height := WorkBitmap.Height;
    WorkCanvas.Canvas.Draw(0,0,WorkBitmap);

    //FBsScanLine荞݁AGRBʂWindowsRGB
    //cprChangêƂF1F2ƔrĈv
    //cprInvcprInvGraŷƂF]
    //cprGraycprInvGraŷƂFω
    //WindowsRGBRGBʕAi[
    for Row :=0 to WorkCanvas.Height -1 do
    begin
      Line := WorkCanvas.ScanLine[Row];
      for Col := 0 to WorkCanvas.Width -1 do
      begin
        CColor := RGB(Line[Col * 3+2],Line[Col * 3+1],Line[Col * 3]);
        case cprMode of
        cprChange:
          begin
            if CColor = Color1 then CColor := Color2
            else if CColor = Color2 then CColor := Color1;
            Line[Col * 3  ] := GetBValue(CColor);
            Line[Col * 3+1] := GetGValue(CColor);
            Line[Col * 3+2] := GetRValue(CColor);
          end;
        cprInv:
          begin
            Line[Col * 3  ] := 255 -GetBValue(CColor);
            Line[Col * 3+1] := 255 -GetGValue(CColor);
            Line[Col * 3+2] := 255 -GetRValue(CColor);
          end;
        cprGray:
          begin
            GrayCode :=(GetBValue(CColor) + GetGValue(CColor)+ GetRValue(CColor)) div 3;
            Line[Col * 3  ] := GrayCode;
            Line[Col * 3+1] := GrayCode;
            Line[Col * 3+2] := GrayCode;
          end;
        cprInvGray:
          begin
            GrayCode :=255 -(GetBValue(CColor) + GetGValue(CColor)+ GetRValue(CColor)) div 3;
            Line[Col * 3  ] := GrayCode;
            Line[Col * 3+1] := GrayCode;
            Line[Col * 3+2] := GrayCode;
          end;
        end;//case cprMode
      end;//for Col
    end;//for row

    //Ɨ̈̃[h摜ɍ킹(A)
    //AJX^rbg}bvꍇ24rbg̃rbg}bvɂ
    //̗̈ɕ`悤ɂAȂ񂩂܂̂ł̏폜B
//    if PixelFormatBU = pfCustom then
//      WorkCanvas.PixelFormat := pf24bit
//    else
//    begin
//      WorkCanvas.PixelFormat := PixelFormatBU;
//    end;

    WorkBitmap.Canvas.Draw(0,0,WorkCanvas);
  finally
    WorkCanvas.Free;
  end;
end;

procedure TMainForm.ColorChangeBatch(Files: TStrings);
var
  i, Res: Integer;
  WorkCanvas: TBitmap;
  FolderName, FileName: String;
  ResultForm: TResultForm;
  ReadFormat: TPixelFormat;
begin
  Res := 0;  //mrYes mrNo mrAbort mrYesToAll
  //摜̏

  ResultForm := TResultForm.Create(Self);
  try
    WorkCanvas := TBitmap.Create;
    try
      for i := 0 to Files.Count -1 do
      begin
        FileName := Files.Strings[i];

        if FolderName <> ExtractFilePath(FileName) then
        begin
          FolderName := ExtractFilePath(FileName);
          ResultForm.AddStringSuccess('tH_:'#9 +FolderName);
        end;

        //ŏImF
        //mFOKȂrbg}bvt@Cǂݍŉ摜A㏑
        //Ȃ񂩁A܂ƐetH[̐^񒆂ɏo@͂Ȃł˂EEE
        if not((Res = mrAbort) or (Res = mrYesToAll)) then
//          Res := MessageDlg(
//            '݂̐ݒŉ摜A㏑܂.' + #10#13 + ExtractFileName(FileName)
//            , mtWarning ,[mbYes, mbNo, mbYesToAll, mbAbort], 0);
//          Res := MessageDlgPos(
//            '݂̐ݒŉ摜A㏑܂.' + #10#13 + ExtractFileName(FileName)
//            , mtWarning ,[mbYes, mbNo, mbYesToAll, mbAbort], 0, Left + Width div 2 , Top + Height div 2 );
          Res := MessageDlgPos(
            '݂̐ݒŉ摜A㏑܂.' + #10#13 + ExtractFileName(FileName)
            , mtWarning ,[mbYes, mbNo, mbYesToAll, mbAbort], 0, -1 , Top + Height div 2 );

        if (Res = mrYes) or (Res = mrYesToAll) then
        try
          WorkCanvas.LoadFromFile(FileName);
          ReadFormat := WorkCanvas.PixelFormat;
          ColorChangeLogic(WorkCanvas, ColorProcRun.ImageIndex);
          WorkCanvas.SaveToFile(FileName);

          if WorkCanvas.PixelFormat = ReadFormat then
            ResultForm.AddStringSuccess(cprModeToString(ColorProcRun.ImageIndex)
                                      + '܂:'#9
                                      + ExtractFileName(FileName))
          else
            ResultForm.AddStringChange('tH[}bgύX܂:'#9
                                      + ExtractFileName(FileName) + #9
                                      + PixelFormatToString(ReadFormat) + '  '
                                      + PixelFormatToString(WorkCanvas.PixelFormat) );
        except
           on EInvalidGraphic do
            ResultForm.AddStringAlert('ł܂ł:'#9
                                      + ExtractFileName(FileName) +#9
                                      + 'T|[gtH[}bg' );
        end;
      end;
      ResultForm.ShowModal;
    finally
      WorkCanvas.Free;
    end;
  finally
    ResultForm.Release;
  end;
end;

function TMainForm.PixelFormatToString(PixelFormat: TPixelFormat): String;
begin
  case PixelFormat of
    pfDevice: Result := 'foCXˑtH[}bg';
    pf1Bit: Result := '1bit : mN rbg}bv';
    pf4Bit: Result := '4bit : 16F rbg}bv';
    pf8Bit: Result := '8bit : 256F rbg}bv';
    pf15Bit: Result := '15bit : TrueColor(RGB Comp)rbg}bv';
    pf16Bit: Result := '16bit : TrueColor(BitField)rbg}bv';
    pf24Bit: Result := '24bit : TrueColorrbg}bv';
    pf32Bit: Result := '32bit : TrueColor(RGB Comp)rbg}bv';
    pfCustom: Result := 'Custom : JX^tH[}bgrbg}bv';
  else
    Result := 'Unknwon : T|[gtH[}bg';
  end;
end;

function TMainForm.cprModeToString(cprMode: Integer): String;
begin
  case cprMode of
    cprChange:  Result := 'F[h';
    cprInv:     Result := 'F][h';
    cprGray:    Result := 'O[XP[';
    cprInvGray: Result := ']O[XP[';
  end;
end;


function TMainForm.ApplicationEvents1Help(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
var
  Topic: String;
begin
  //󋵈ˑwv
  CallHelp:= False;
  Result := True;
  case Command of
  HELP_CONTEXT://ReLXg
    Application.HelpSystem.ShowContextHelp(Data, Application.HelpFile);
  HELP_CONTEXTPOPUP://{Ȃ|bvAbvǕʂɕ\
    Application.HelpSystem.ShowContextHelp(Data, Application.HelpFile);
  HELP_SETPOPUP_POS:;//{Ȃ|bvAbv\̏
  HELP_COMMAND://gsbN
    begin
      Topic := String(PChar(Data));
      Application.HelpSystem.ShowTopicHelp(Topic, Application.HelpFile);
    end;
  else
//    Application.HelpSystem.ShowTopicHelp('hmIndex.html', Application.HelpFile);
    Application.HelpSystem.ShowContextHelp(1000, Application.HelpFile);
  end;

end;

procedure TMainForm.Gradation(Canvas: TCanvas; ARect: TRect; Color: TColor);
var
  StartColor: TColor;
  EndColor: TColor;
begin
  StartColor := GetHighLightColor(Color ,19);
  EndColor := GetShadowColor(Color ,-50);
  GradientFillCanvas(Canvas, StartColor, EndColor, ARect, gdVertical);
end;


procedure TMainForm.HelpWindowInitialize;
begin

{ߋ̈╨BsN`J肵ɃwvJȂȂւ̑ΏB
Ȃ񂩂ˁ[AJgfBNg̖ۂB

var
  phhWinType: PtagHH_Wintype;
//  hhWinType: TtagHH_Wintype;
  HH_WindowName: string;
begin
  //wv𑀍삷邽߂Ƀwvt@C̃EBhEݒǂݏo
  //wb for XP̃wvt@C̓ftHgEBhEMainWin_wbXPB
  //}CN\tg̐ł͓n̈structȊO̓NAĂƂB
  //AllocMemŗ̈mہ0NÂƁA
  //varŗ̈mۂFillCharŃNÂƂǂǂ݂₷낤H
  HH_WindowName := Application.HelpFile + '>MainWin_wbXP';
  phhWinType := AllocMem(SizeOf(TtagHH_WINTYPE));
  try
    phhWinType.cbStruct := SizeOf(TtagHH_WINTYPE);
    HtmlHelp(GetDesktopWindow, PChar(HH_WindowName), HH_GET_WIN_TYPE, DWORD(Pointer(phhWinType)));
//    FillChar(hhWinType, SizeOf(TtagHH_WINTYPE)), 0;
//    hhWinType.cbStruct := SizeOf(TtagHH_WINTYPE);
//    HtmlHelp(GetDesktopWindow, PChar(HH_WindowName), HH_GET_WIN_TYPE, DWORD(@hhWinType));
  finally
    FreeMem(phhWinType);
  end;
  //AphhWinType̒lCȂ΁Aɍ\̂̃fB[vRs[{邱
  //(\̊eڂ̗̈mۂẴRs[)
  //܂ASET_WIN_TYPEɍ\̂n̍ڂ̓Rs[̂ŁA
  //mۂ͉̈Ȃ΂ȂȂ
  //ł܂ĂԂƂɂ͂܂ĂȂ͂璆gۂ̂͂ǂˁB
  //wvt@CAvP[Vׂ̗ɂƂlƁAɑ\̂ŃElElႤ悽ԂB

}
end;


procedure TMainForm.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
  //ҏWANVgp?
  ColorPick1.Enabled := Image1.Visible;
  ColorPick2.Enabled := Image1.Visible;
  ColorChange.Enabled := Image1.Visible;
  EditCopy1.Enabled := Image1.Visible;
  SavePicture1.Enabled := Image1.Visible;

end;

end.
